//////////////////////////////////////////////////////////////////
//Aufgabe 2 im Kapitel Nebenläufige Programmierung
/////////////////////////////////////////////////////////////////

ArrayList<MyThread> threads;
double xmin = -2.5; 
double ymin = -2; 
double wh = 4;
int maxiterations = 4000;//nur zur Demo , 400 reichen
double massFuerUnendlich = 4000;//auch hier
double x0 = -1;
double y0 = 1;
int anzahlThreads = Runtime.getRuntime().availableProcessors(); 

void setup() {
  background(255);
  noLoop();
  colorMode(HSB);
  threads = new  ArrayList<MyThread>(); 
  size(1200, 1200);
  println("Anzahl Threads: "+anzahlThreads);
// starte anzahlThreads Threads
  starteThreads(xmin, ymin, maxiterations, massFuerUnendlich, wh);
  
}

/////////////////////////////////////////////////////////////////

void starteThreads(double px, double py, int pmaxiterations, double pUnendlich, double pwh){
  
  xmin = px; ymin = py;
  maxiterations = pmaxiterations;
  massFuerUnendlich = pUnendlich;
  wh = pwh;
  for (double y= ymin; y<(ymin+wh); y=y+wh/anzahlThreads) {
        MyThread t = new MyThread(xmin,y,maxiterations,massFuerUnendlich,wh/anzahlThreads);
      
        threads.add(t);
        t.start(); 
        delay(50);//zur Verringerung der Pixelfehler
   }  
}
//////////////////////////////////////////////////////////////

void draw() {
  
  // die Draw-Methode fügt die PGraphics-Zeichenflächen
  // der Threads zu einem Bild zusammen
  // Warten bis alle Threads fertig sind
 
  for(MyThread t: threads){
      while (t.running){       
            try{
            Thread.sleep(10);  
            }catch (Exception e) {  }  ;                
       }
  }
  
  for (int i=0; i<threads.size(); i++){
    image(threads.get(i).pg,0,i*height/anzahlThreads);
  }  
     
}

/////////////////////////////////////////////////////////////////
void mousePressed() {
   threads = new  ArrayList<MyThread>(); 
  // berechne, wo der Mauszeiger im gezeigten Ausschnitt der komplexen
  // Zahlenebene ist (Transformation Pixelposition nach (x,y))
  double x = xmin + wh*mouseX/width;
  double y = ymin + wh*mouseY/height;
  
  // linke Maustaste: verkleinere den gezeigten Ausschnitt um 0.66
  // rechte Taste: vergrößere den gezeigten Ausschnitt entsprechend
  if (mouseButton == LEFT) wh*=0.5; 
  else wh/=0.5;

  // bestimme den neuen gezeigten Ausschnitt
  xmin = x-wh/2.0;
  ymin = y-wh/2.0;
  starteThreads(xmin, ymin, maxiterations, massFuerUnendlich, wh);

  redraw();
}  
/////////////////////////////////////////////////////////////////
void keyPressed() {
  if (key == '+'){
    maxiterations *= 1.2;
    threads = new  ArrayList<MyThread>(); 
    starteThreads(xmin, ymin, maxiterations, massFuerUnendlich, wh);
  }
  if (key == '-') {
    maxiterations /= 1.2;
    threads = new  ArrayList<MyThread>(); 
    starteThreads(xmin, ymin, maxiterations, massFuerUnendlich, wh);  
  }
  if (key == 's') save("mandelbrot.png");
  redraw();
}
/////////////////////////////////////////////////////////////////